VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsVideoInput"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type
Private Type STARTUPINFO
    cB As Long
    lpReserved As Long
    lpDesktop As Long
    lpTitle As Long
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type
Private Type PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessId As Long
    dwThreadId As Long
End Type
Private Type PIPE
    hReadPipe As Long
    hWritePipe As Long
End Type
Private Const STARTF_USESHOWWINDOW = &H1
Private Const STARTF_USESTDHANDLES = &H100
Private Const SW_HIDE = 0
Private Declare Function CreatePipe Lib "kernel32" (phReadPipe As Long, phWritePipe As Long, lpPipeAttributes As SECURITY_ATTRIBUTES, ByVal nSize As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" (ByVal lpApplicationName As Long, ByVal lpCommandLine As String, lpProcessAttributes As Any, lpThreadAttributes As Any, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As Long, lpStartupInfo As Any, lpProcessInformation As Any) As Long
Private Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function PeekNamedPipe Lib "kernel32" (ByVal hNamedPipe As Long, lpBuffer As Any, ByVal nBufferSize As Long, lpBytesRead As Long, lpTotalBytesAvail As Long, lpBytesLeftThisMessage As Long) As Long
Private Declare Function FlushFileBuffers Lib "kernel32" (ByVal hFile As Long) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Sub memcpy Lib "kernel32" Alias "RtlMoveMemory" (ByVal lpvDest As Long, lpvSource As Any, ByVal cbCopy As Long)
'Private Declare Function WriteFileData Lib "kernel32" Alias "WriteFile" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long
'Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
'Private Declare Function DeleteFile Lib "kernel32" Alias "DeleteFileA" (ByVal lpFileName As String) As Long

Private pipeOut As PIPE, pipeIn As PIPE
Private Process As PROCESS_INFORMATION
Dim StartInfo As STARTUPINFO
Dim Attribs As SECURITY_ATTRIBUTES
Private BSize As Long

Dim FFMPEG As String

Public MaxFrames As Long
Public File_Name As String

Public Total_Frames As Long
Public fWidth As Long
Public fHeight As Long
Public FPS As Single
Public BitD As Long

Dim IsClosed As Long

Dim FrameData() As Byte
Dim StartFrame As Long, StartFrameOn As Long
Public FrameLength As Long

Public Function SetFFMPEG(exePath As String) As Long
    If Len(exePath) = 0 Then SetFFMPEG = 1: Exit Function
    If Len(Dir$(exePath)) = 0 Then SetFFMPEG = 1: Exit Function
    If FileLen(exePath) <= 0 Then SetFFMPEG = 2: Exit Function
    FFMPEG = exePath
End Function

Private Function GetResolution(s As String, W As Long, H As Long) As Long
    Dim L As Long
    Dim N As Long, v As Long, sd() As String
    Dim st As Long
    Dim p As Long
    Dim isX As Long
    
    L = Len(s)
    
    p = 1
    For N = 1 To L
        v = Asc(Mid$(s, N, 1))
        If v >= 48 And v <= 57 Or v = 120 Then
            If st = 0 Then
                p = N
                st = 1
                isX = 0
            Else
                If v = 120 Then isX = 1
            End If
        Else
            If st = 1 Then
                If isX = 1 Then
                    sd = Split(Mid$(s, p, N - p), "x")
                    If sd(0) <> "" Then
                        If Val(sd(0)) <> 0 Then
                            W = Val(sd(0))
                            H = Val(sd(1))
                            GetResolution = 1
                            Exit Function
                        End If
                    End If
                End If
                st = 0
            End If
        End If
    Next
    GetResolution = 0
End Function

Private Function GetFPS(s As String) As Single
    On Error Resume Next
    Dim i As Long, i2 As Long
    i = InStr(1, s, " fps")
    If i <> 0 Then
        i2 = InStrRev(s, " ", i - 1)
        If i2 <> 0 Then
            GetFPS = Val(Mid$(s, i2 + 1, i + i2 - 1))
        End If
    End If
End Function

Public Sub CloseVideo()
    IsClosed = 1
    File_Name = ""
    Erase FrameData()
End Sub

Public Function OpenVideo(FileName As String, Optional ByVal CacheSize As Long = 134217728, Optional ByVal BitDepth As Long = 8) As Long
    If Len(FileName) = 0 Then OpenVideo = 1: Exit Function
    If Len(Dir$(FileName)) = 0 Then OpenVideo = 1:  Exit Function
    If FileLen(FileName) <= 0 Then OpenVideo = 2: Exit Function
    Dim bf() As Byte
    ReDim bf(8191)
    Dim p As Long
    
    Dim L As Long, N As Long, i As Long
    Dim s As String, sd() As String, dd() As String
    Dim tm As Double
    Dim Dur As Single
    Dim lFPS As Single
    Dim W As Long, H As Long
    
    
    IsClosed = 0
    File_Name = ""
    Total_Frames = 0
    Dur = 0
    lFPS = 0
    W = 0
    H = 0
    StartFrameOn = 0
    
    tm = Timer
    BitD = BitDepth
    
    
    p = 1
    
    OpenPipe FFMPEG & " -i " & Chr$(34) & FileName & Chr$(34), 4096
    Do
        If IsClosed = 1 Then
            ClosePipe
            Exit Do
        End If
        
        L = Read(VarPtr(bf(0)))
        If L > 0 Then
            s = StrConv(bf, vbUnicode)
            sd = Split(s, vbCrLf)
            For N = 0 To UBound(sd)
                'Invalid data found when processing input
                
                If InStr(1, sd(N), "Duration: N/A") > 0 Then ClosePipe: OpenVideo = 4:  Exit Function
                If InStr(1, sd(N), "Invalid data found when processing input") > 0 Then ClosePipe: OpenVideo = 5: Exit Function
                
                i = InStr(1, sd(N), "Duration:")
                If i <> 0 Then
                    dd = Split(Mid$(sd(N), i + 10, Len(sd(N)) - (i + 10)), ",")
                    If Len(dd(0)) = 8 Then
                        Dur = Val(Mid$(dd(0), 1, 2)) * 3600 + Val(Mid$(dd(0), 4, 2)) * 60 + Val(Mid$(dd(0), 7, 2))
                    ElseIf Len(dd(0)) = 11 Then
                        Dur = Val(Mid$(dd(0), 1, 2)) * 3600 + Val(Mid$(dd(0), 4, 2)) * 60 + Val(Mid$(dd(0), 7, 2)) + Val(Mid$(dd(0), 10, 2)) / 100
                    End If
                End If
                
                i = InStr(1, sd(N), "Video:")
                If i <> 0 Then
                    'dd = Split(Mid$(sd(n), i + 7, Len(sd(n)) - (i + 7)), ",")
                    GetResolution sd(N), W, H
                    lFPS = GetFPS(sd(N)) 'Mid$(sd(n), i + 7, Len(sd(n)) - (i + 7)))
                End If
                
            Next
            If Dur <> 0 And lFPS <> 0 And W <> 0 And H <> 0 Then
                fWidth = W
                fHeight = H
                FPS = lFPS
                Total_Frames = Dur * lFPS
                File_Name = FileName
                
                FrameLength = (fWidth * fHeight * 3 * (BitDepth \ 8))
                MaxFrames = CacheSize \ FrameLength
                ReDim FrameData(CacheSize - 1) 'MaxFrames * FrameLength - 1)

                OpenVideo = 0
                ClosePipe
                Exit Function
            End If
            
            Open App.Path & "\ffmpeglog.txt" For Binary As #1
                Put #1, p, bf
            Close #1
            p = p + L
        End If
        DoEvents
        Sleep 1
        If (Timer - tm) > 5 Then
            
            Exit Do
        End If
    Loop
    
    Erase FrameData()
    OpenVideo = 3
    ClosePipe
End Function

Public Sub SaveFramesCache(FileName As String)
    On Error Resume Next
    Open FileName For Binary As #1
        Put #1, 1, FrameData
    Close #1
End Sub


Public Function GetFrame(ByVal frame As Long, DataPTR As Long) As Long
    If Len(File_Name) = 0 Then GetFrame = 1: Exit Function
    If fWidth = 0 Or fHeight = 0 Then GetFrame = 1: Exit Function
    If frame > Total_Frames - 1 Then frame = Total_Frames - 1
    
    
    Dim tmm As String
    'Dim bff() As Byte
    Dim FrameDataLength As Long
    Dim bffs As String
    Dim bffb() As Byte
    ReDim bffb(1048576)
    
    Dim strBuf(4095) As Byte
    Dim tm As Double: tm = Timer
    Dim frmc As Long
    Dim ColSpace As String
    Dim cmd As String


    DataPTR = 0
    
    tmm = Replace$(Format$(frame / FPS, "0.000"), ",", ".")
    
    If frame >= StartFrame And frame < StartFrame + MaxFrames And StartFrameOn = 1 Then
        DataPTR = VarPtr(FrameData((frame - StartFrame) * FrameLength))
        Exit Function
    End If
    
    frmc = MaxFrames
    If frame + frmc > Total_Frames - 1 Then frmc = Total_Frames - frame

    If BitD = 8 Then
        ColSpace = "-pix_fmt bgr24"
    ElseIf BitD = 16 Then
        ColSpace = "-pix_fmt rgb48le"
    Else
        ColSpace = "-pix_fmt bgr24"
    End If
    
    
    cmd = FFMPEG & " -nostats -hide_banner -ss " & tmm & " -i " & Chr$(34) & File_Name & Chr$(34) & " -map 0:0 -f image2pipe " & ColSpace & " -vcodec rawvideo -vframes " & frmc & " -"
    
    OpenPipe cmd, 524288 '32768

    StartFrame = frame
    
    Dim L As Long, SML As Long
    Dim p As Long, pl As Long, cl As Long, st As Long, i As Long
    FrameDataLength = FrameLength * MaxFrames
    
    StartFrameOn = 0
    p = 0: pl = 0
    st = 0
    SML = 0
    Do
        If IsClosed = 1 Then
            ClosePipe
            Exit Do
        End If
        
        DoEvents
        L = Read(VarPtr(bffb(0)))
        
        If L > 0 Then
            tm = Timer
            SML = SML + L
            
            If st = 0 Then
                memcpy VarPtr(strBuf(0)), bffb(0), 4096
                bffs = StrConv(strBuf, vbUnicode)
                
                i = InStr(1, bffs, "Press [q] to stop") + 33
                If i > 33 Then
                    cl = (L - i + 1)
                    memcpy VarPtr(FrameData(p)), bffb(i - 1), cl
                    p = p + cl
                    pl = pl + cl
                    st = 1
                End If

            Else
                cl = L
                If pl + cl > FrameDataLength Then
                    cl = FrameDataLength - p
                End If
                memcpy VarPtr(FrameData(p)), bffb(0), cl

                p = p + cl
                pl = pl + cl
                If p >= FrameDataLength Then
                    DataPTR = VarPtr(FrameData((frame - StartFrame) * FrameLength))
                    StartFrameOn = 1
                    Exit Do
                End If
                
            End If
        
        End If
        DoEvents
        Sleep 1
        If (Timer - tm) > 2.5 Then
            If SML >= FrameLength Then
                DataPTR = VarPtr(FrameData((frame - StartFrame) * FrameLength))
            End If
            Exit Do
        End If
    Loop
    
    If DataPTR > 0 Then
        StartFrameOn = 1
    Else
        GetFrame = 5
    End If
    
    ClosePipe
End Function


Private Sub OpenPipe(cmds As String, Optional ByVal BufferSize As Long = -1)
    Dim Result As Long
    Attribs.nLength = Len(Attribs)
    Attribs.bInheritHandle = 1
    Attribs.lpSecurityDescriptor = 0&
    Result = CreatePipe(pipeOut.hReadPipe, pipeOut.hWritePipe, Attribs, BufferSize) 'BufferSize)
    Result = CreatePipe(pipeIn.hReadPipe, pipeIn.hWritePipe, Attribs, BufferSize)
    StartInfo.cB = Len(StartInfo)
    StartInfo.hStdInput = pipeIn.hReadPipe
    StartInfo.hStdOutput = pipeOut.hWritePipe
    StartInfo.hStdError = pipeOut.hWritePipe
    StartInfo.dwFlags = STARTF_USESTDHANDLES + STARTF_USESHOWWINDOW
    StartInfo.wShowWindow = SW_HIDE
    BSize = BufferSize
    Result = CreateProcess(0&, cmds, Attribs, Attribs, ByVal 1&, 0&, ByVal 0&, ByVal 0&, StartInfo, Process)
    CloseHandle Process.hThread
End Sub
Private Function Read(ByVal BuffPTR As Long) As Long
    Dim tBytesR As Long
    Dim RecBytes As Long
    Dim tMsg As Long
    Dim Result As Long
    
    Result = PeekNamedPipe(pipeOut.hReadPipe, ByVal 0&, BSize, tBytesR, RecBytes, tMsg)
    If Result <> 0 And RecBytes > 0 Then
        Result = ReadFile(pipeOut.hReadPipe, ByVal BuffPTR, RecBytes, tBytesR, ByVal 0&)
        Read = RecBytes
    Else
        If Result = 0 Then Err.Raise vbObjectError + 504, "DOSShell Class", "Error: ReadFile failed. " & Err.LastDllError
    End If
    
    FlushFileBuffers pipeOut.hReadPipe
End Function
Private Sub ClosePipe()
    On Error Resume Next
    TerminateProcess Process.hProcess, 0
    CloseHandle Process.hProcess
    CloseHandle Process.hThread
    CloseHandle pipeIn.hReadPipe
    CloseHandle pipeIn.hWritePipe
    CloseHandle pipeOut.hReadPipe
    CloseHandle pipeOut.hWritePipe
End Sub

